<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
<!--      <el-form-item label="学校" prop="schoolId">-->
<!--        <el-input-->
<!--                v-model="queryParams.schoolId"-->
<!--                placeholder="请输入学校"-->
<!--                clearable-->
<!--                @keyup.enter="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="所在校区" prop="schoolId">
        <el-select
                v-model="queryParams.schoolId"
                placeholder="请选择所在校区"
                clearable
                style="width: 240px"
                @keyup.enter="handleQuery"
        >
          <el-option
                  v-for="item in schoolOptions"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="开班年份" prop="year">
        <el-input
                v-model="queryParams.year"
                placeholder="请输入开班年份"
                clearable
                @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="名称" prop="name">
        <el-input
                v-model="queryParams.name"
                placeholder="请输入名称"
                clearable
                @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="是否线上" prop="online">
        <el-select v-model="queryParams.online" placeholder="请选择是否线上" clearable style="width: 170px;">
          <el-option
                  v-for="dict in bool_values"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-input
                v-model="queryParams.status"
                placeholder="请输入状态"
                clearable
                @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
                type="primary"
                plain
                icon="Plus"
                @click="handleAdd"
                v-hasPermi="['dz:classes:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
                type="success"
                plain
                icon="Edit"
                :disabled="single"
                @click="handleUpdate"
                v-hasPermi="['dz:classes:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
                type="danger"
                plain
                icon="Delete"
                :disabled="multiple"
                @click="handleDelete"
                v-hasPermi="['dz:classes:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
                type="warning"
                plain
                icon="Download"
                @click="handleExport"
                v-hasPermi="['dz:classes:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="classesList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="classId" />
      <el-table-column label="名称" align="center" prop="name" />
<!--      <el-table-column label="学校" align="center" prop="schoolId" />-->
      <el-table-column label="学校" align="center" prop="school.name" />
      <el-table-column label="开班年份" align="center" prop="year" />
      <el-table-column label="是否线上" align="center" prop="online">
        <template #default="scope">
          <dict-tag :options="bool_values" :value="scope.row.online"/>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="status">
        <template #default="scope">
          <dict-tag :options="bool_values" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="统计数据" align="center" prop="stats" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['dz:classes:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['dz:classes:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
            v-show="total>0"
            :total="total"
            v-model:page="queryParams.pageNum"
            v-model:limit="queryParams.pageSize"
            @pagination="getList"
    />

    <!-- 添加或修改学生班级对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="classesRef" :model="form" :rules="rules" label-width="80px">
<!--        <el-form-item label="学校" prop="schoolId">-->
<!--          <el-input v-model="form.schoolId" placeholder="请输入学校" />-->
<!--        </el-form-item>-->
        <el-form-item label="班级名称" prop="name">
          <el-input v-model="form.name" placeholder="多个名称使用英文逗号隔开" />
        </el-form-item>
        <el-form-item label="所在校区" prop="schoolId">
          <el-select v-model="form.schoolId" placeholder="请选择所在校区" style="width: 100%">
            <el-option
                    v-for="item in schoolOptions"
                    :key="item.id"
                    :label="item.name"
                    :value="item.id"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="开班年份" prop="year">
          <el-input v-model="form.year" placeholder="请输入开班年份" />
        </el-form-item>

        <el-form-item label="是否线上" prop="online">
          <el-select v-model="form.online" placeholder="请选择是否线上">
            <el-option
                    v-for="dict in bool_values"
                    :key="dict.value"
                    :label="dict.label"
                    :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <el-input v-model="form.status" placeholder="请输入状态" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Classes">
  import { listClasses, getClasses, delClasses, addClasses, updateClasses } from "@/api/dz/classes"
  import { listAllSchool } from "@/api/dz/school"

  const { proxy } = getCurrentInstance()
  const { bool_values } = proxy.useDict('bool_values')

  const classesList = ref([])
  const schoolOptions = ref([])
  const open = ref(false)
  const loading = ref(true)
  const showSearch = ref(true)
  const ids = ref([])
  const single = ref(true)
  const multiple = ref(true)
  const total = ref(0)
  const title = ref("")

  const data = reactive({
    form: {},
    queryParams: {
      pageNum: 1,
      pageSize: 10,
      schoolId: null,
      year: null,
      name: null,
      online: null,
      status: null,
      stats: null,
    },
    rules: {
      name: [
        { required: true, message: "名称不能为空", trigger: "blur" }
      ],
      schoolId: [
        { required: true, message: "所在校区不能为空", trigger: "blur" }
      ],
      online: [
        { required: true, message: "是否线上不能为空", trigger: "change" }
      ],
    }
  })

  const { queryParams, form, rules } = toRefs(data)

  /** 查询学生班级列表 */
  function getList() {
    loading.value = true
    listClasses(queryParams.value).then(response => {
      classesList.value = response.rows
      total.value = response.total
      loading.value = false
    })
  }

  /** 查询校区列表 */
  function getSchoolList() {
    listAllSchool().then(response => {
      schoolOptions.value = response.data || []
    })
  }

  // 取消按钮
  function cancel() {
    open.value = false
    reset()
  }

  // 表单重置
  function reset() {
    form.value = {
      classId: null,
      schoolId: null,
      year: null,
      name: null,
      online: null,
      status: null,
      stats: null,
      createTime: null,
      updateTime: null
    }
    proxy.resetForm("classesRef")
  }

  /** 搜索按钮操作 */
  function handleQuery() {
    queryParams.value.pageNum = 1
    getList()
  }

  /** 重置按钮操作 */
  function resetQuery() {
    proxy.resetForm("queryRef")
    handleQuery()
  }

  // 多选框选中数据
  function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.classId)
    single.value = selection.length != 1
    multiple.value = !selection.length
  }

  /** 新增按钮操作 */
  function handleAdd() {
    reset()
    open.value = true
    title.value = "添加学生班级"
  }

  /** 修改按钮操作 */
  function handleUpdate(row) {
    reset()
    const _classId = row.classId || ids.value
    getClasses(_classId).then(response => {
      form.value = response.data
      open.value = true
      title.value = "修改学生班级"
    })
  }

  /** 提交按钮 */
  function submitForm() {
    proxy.$refs["classesRef"].validate(valid => {
      if (valid) {
        if (form.value.classId != null) {
          updateClasses(form.value).then(response => {
            proxy.$modal.msgSuccess("修改成功")
            open.value = false
            getList()
          })
        } else {
          addClasses(form.value).then(response => {
            proxy.$modal.msgSuccess("新增成功")
            open.value = false
            getList()
          })
        }
      }
    })
  }

  /** 删除按钮操作 */
  function handleDelete(row) {
    const _classIds = row.classId || ids.value
    proxy.$modal.confirm('是否确认删除学生班级编号为"' + _classIds + '"的数据项？').then(function() {
      return delClasses(_classIds)
    }).then(() => {
      getList()
      proxy.$modal.msgSuccess("删除成功")
    }).catch(() => {})
  }

  /** 导出按钮操作 */
  function handleExport() {
    proxy.download('dz/classes/export', {
      ...queryParams.value
    }, `classes_${new Date().getTime()}.xlsx`)
  }

  onMounted(() => {
    getSchoolList()
    getList()
  })
</script>
